/***************************************************************************
 * Copyright 2001-2003 The eXo Platform SARL         All rights reserved.  *
 * Please look at license.txt in info directory for more license detail.   *
 **************************************************************************/
package org.exoplatform.faces.core.component;

import java.util.Map ;

import java.io.IOException  ;

import javax.faces.context.FacesContext;
import javax.faces.context.ResponseWriter;
/**
 * Wed, Dec 22, 2003 @ 23:14 
 * @author: Tuan Nguyen
 * @email:   tuan08@users.sourceforge.net
 * @version: $Id: UICheckBox.java,v 1.4 2004/08/23 15:05:41 benjmestrallet Exp $
 */
public class UICheckBox extends UIInput {
  protected String value_ ;
  protected boolean isCheck_ ;

  public UICheckBox(String name, String text) {
    name_ = name ;
    value_ = text;
    isCheck_ = false ;
  }

  final public String getValue() { return value_ ; }

  final public UICheckBox setValue(String s) { 
    value_ = s ; 
    return this ;
  }

  final public boolean getSelect() { return isCheck_ ; }
  final public UICheckBox setSelect(boolean b) { 
    isCheck_ = b ; 
    return this ;
  }

  public void decode(FacesContext context) {
    if (!editable_ || readonly_) return ;
    Map paramMap = context.getExternalContext().getRequestParameterMap() ;
    String value = (String) paramMap.get(name_) ;
    if (value == null) {
      isCheck_ = false ;
    } else {
      isCheck_ = true ;
    }
  }

  public void encodeBegin(FacesContext context) throws IOException {
    ResponseWriter w = context.getResponseWriter() ;
    String value = value_ ;
    if (value == null) value = "" ;
    String check = "" ;
    if (isCheck_) check = " checked" ;
    w.write("<input type='checkbox' name='"); w.write(name_); w.write("'") ;
    w.write(" value='"); w.write(value); w.write("' ");
    w.write(check) ;
    if (!editable_ || readonly_) {
      w.write(" readonly='readonly'");
    }
    w.write(" class='checkbox'/>") ;
  }
}

