/***************************************************************************
 * Copyright 2001-2003 The eXo Platform SARL         All rights reserved.  *
 * Please look at license.txt in info directory for more license detail.   *
 **************************************************************************/
package org.exoplatform.faces.core.component;

import javax.faces.context.FacesContext;
import javax.faces.validator.Validator ;
import org.exoplatform.faces.FacesUtil;

/**
 * Wed, Dec 22, 2003 @ 23:14
 * @author: Tuan Nguyen
 * @email:   tuan08@users.sourceforge.net
 * @version: $Id: UIStringInput.java,v 1.11 2004/08/18 02:37:24 tuan08 Exp $
 */
public class UIStringInput extends UIInput {
  public static final String  COMPONENT_FAMILY = "org.exoplatform.faces.core.component.UIStringInput" ;
  public static final int TEXT = 0;
  public static final int PASSWORD = 1;

  protected String value_ ;
  protected String title_ ;
  protected int type = 0;

  public UIStringInput(String name, String text) {
  	setId(name) ;
    name_ = name ;
    value_ = text;
    scripting_ = null;
    editable_ = true ;
    setRendererType("StringInputRenderer") ;
    FacesUtil.createValueBinding(getFacesContext(), this, "text", text);
  }

  public UIStringInput(String name, String text, String scripting) {
    setId(name);
    name_ = name;
    value_ = text;
    scripting_ = scripting;
    editable_ = true;
    setRendererType("StringInputRenderer");
    FacesUtil.createValueBinding(getFacesContext(), this, "text", text);
  }

  public String getFamily() {  return COMPONENT_FAMILY ; }

  final public String getValue() { return value_ ; }
  final public UIStringInput setValue(String s) {
    value_ = s ;
    return this ;
  }

  final public String getText() { return value_ ; }
  final public UIStringInput setText(String s) {
    value_ = s ;
    return this ;
  }

  final public String getTitle() { return title_ ; }
  final public UIStringInput setTitle(String title) {
    title_ = title ;
    return this ;
  }

  public int getType() {
    return type;
  }
  public void setType(int type) {
    this.type = type;
  }

  public UIStringInput addValidator(Validator validator) {
    addComponentValidator(validator) ;
    return this ;
  }

  public UIStringInput addValidator(Class clazz) {
    addComponentValidator(clazz) ;
    return this ;
  }

  final public  void processValidators(FacesContext context) {
    processValidators(context, value_) ;
  }
}