/***************************************************************************
 * Copyright 2001-2003 The eXo Platform SARL         All rights reserved.  *
 * Please look at license.txt in info directory for more license detail.   *
 **************************************************************************/
package org.exoplatform.services.communication.forum.hibernate;

import java.util.zip.ZipFile;
import java.util.zip.ZipOutputStream;
import net.sf.hibernate.Session;
import org.picocontainer.Startable;
import org.exoplatform.services.backup.ImportExportPlugin;
import org.exoplatform.services.backup.ImportExportService;
import org.exoplatform.services.backup.Metadata;
import org.exoplatform.services.database.XResources;
/**
 * May 27, 2004 
 * @author: Tuan Nguyen
 * @email:   tuan08@users.sourceforge.net
 * @version: $ID$
 **/
public class ImportExportPluginImpl extends ImportExportPlugin implements Startable {
  static String SERVICE_META_DATA_ENTRY   = "metadata.xml" ;

  public ImportExportPluginImpl(ImportExportService ieservice) throws Exception {
    setName("forum");
    setDescription("forum import/export plugin") ;
    ieservice.addPlugin(this) ;
    init() ;
  }
  
  public boolean hasUserData()  { return false ;  }
  
  public void exportUserData(String user, XResources resources, ZipOutputStream os) throws Exception {
   
  }

  public void importUserData(String user, XResources resources, ZipFile in) throws Exception {
  }

  public void exportServiceData(XResources resources, ZipOutputStream os) throws Exception {
    Metadata mdata = new Metadata(getCurrentDataVersion(), getDescription(), "single-service") ;
    createEntry(SERVICE_META_DATA_ENTRY , os, mdata) ; 
    Session session = (Session) resources.getResource(Session.class) ;
    ForumExporter exporter = new ForumExporter(session, os) ;
    exporter.export() ;
  }

  public void importServiceData(XResources resources, ZipFile in) throws Exception {
    Session session = (Session) resources.getResource(Session.class) ;
    ForumImporter importer = new ForumImporter(this, session,in) ;
    importer.importData() ;
  }

  public void start() {  }

  public void stop() {  }
}